/* 
Script de testeo de los Procedimientos de la BBDD.
PFC - Base de dades
Autor: Alfredo del Valle Lpez
*/

set serveroutput on;
declare 
salida VARCHAR (200);

BEGIN

-- Test de altaPaciente
--altaPaciente(P_DNI =>'48524689V', P_provincia=>35, P_nombre=>'Sonia',P_apellido1=>'Perez',P_apellido2=>'Espinosa', resultado=>salida); --Paciente OK.
--altaPaciente(P_DNI =>'48524689V', P_provincia=>35, P_nombre=>'Sonia',P_apellido1=>'Perez',P_apellido2=>'Espinosa', resultado=>salida); --Fallo: Paciente existe.
--altaPaciente(P_DNI =>'33601214S', P_provincia=>60, P_nombre=>'Perico',P_apellido1=>'de los Palotes',resultado=>salida); --Fallo: cdigo provincia no existe.

-- Test de modPaciente
--modPaciente(P_ID =>1, P_DNI =>'48524689V', P_provincia=>35, P_nombre=>'Sonia Beatriz',P_apellido1=>'Perez',P_apellido2=>'Espinosa', resultado=>salida); --Cambiar nombre paciente 1. OK.
--modPaciente(P_ID =>2, P_DNI =>'48524689V', P_provincia=>35, P_nombre=>'Sonia',P_apellido1=>'Perez',P_apellido2=>'Espinosa', resultado=>salida); --Fallo: El Paciente no existe.

-- Test de bajaPaciente
--bajaPaciente(P_ID =>1, resultado=>salida); --Baja Paciente 1. OK.
--bajaPaciente(P_ID =>5000, resultado=>salida);  --Fallo: El Paciente no existe.

-- Test de altaEnfermero
--altaEnfermero(P_DNI =>'45812344A', P_centro=>273, P_nombre=>'Rosa',P_apellido1=>'Perez',P_apellido2=>'Acosta', resultado=>salida); --Enfermero OK.
--altaEnfermero(P_DNI =>'45812344A', P_centro=>273, P_nombre=>'Rosa',P_apellido1=>'Perez',P_apellido2=>'Acosta', resultado=>salida); --Fallo: Enfermero existe.
--altaEnfermero(P_DNI =>'33601214S', P_centro=>300, P_nombre=>'Perico',P_apellido1=>'de los Palotes',resultado=>salida); --Fallo: cdigo centro no existe.

-- Test de modEnfermero
--modEnfermero(P_ID =>1, P_DNI =>'45812344A', P_centro=>273, P_nombre=>'Rosa Maria',P_apellido1=>'Perez',P_apellido2=>'Acosta', resultado=>salida); --Cambiar nombre Enfermero 1. OK.
--modEnfermero(P_ID =>2, P_DNI =>'45812344A', P_centro=>273, P_nombre=>'Rosa',P_apellido1=>'Perez',P_apellido2=>'Acosta', resultado=>salida); --Fallo: El Enfermero no existe.

-- Test de bajaEnfermero
--bajaEnfermero(P_ID =>1, resultado=>salida); --Baja Enfermero 1. OK.
--bajaEnfermero(P_ID =>5000, resultado=>salida);  --Fallo: El Paciente no existe.

-- Test de altaMedico
--altaMedico(P_DNI =>'44701216A', P_centro=>273, P_nombre=>'Teresa',P_apellido1=>'Arteaga',P_apellido2=>'Lopez', resultado=>salida); --Medico OK.
--altaMedico(P_DNI =>'44701216A', P_centro=>273, P_nombre=>'Teresa',P_apellido1=>'Arteaga',P_apellido2=>'Lopez', resultado=>salida); --Fallo: Medico existe.
--altaMedico(P_DNI =>'33601214S', P_centro=>300, P_nombre=>'Perico',P_apellido1=>'de los Palotes',resultado=>salida); --Fallo: cdigo centro no existe.

-- Test de modMedico
--modMedico(P_ID =>1, P_DNI =>'44701216A', P_centro=>273, P_nombre=>'Teresa Maria',P_apellido1=>'Arteaga',P_apellido2=>'Lopez', resultado=>salida); --Cambiar nombre Medico 1. OK.
--modMedico(P_ID =>2, P_DNI =>'44701216A', P_centro=>273, P_nombre=>'Teresa',P_apellido1=>'Arteaga',P_apellido2=>'Lopez', resultado=>salida); --Fallo: El Medico no existe.

-- Test de bajaMedico
--bajaMedico(P_ID =>1, resultado=>salida); --Baja Medico 1. OK.
--bajaMedico(P_ID =>5000, resultado=>salida);  --Fallo: El Medico no existe.

-- Test de altaFarmaceutico
--altaFarmaceutico(P_DNI =>'44927344T', P_centro=>273, P_nombre=>'Jesus',P_apellido1=>'Vega',P_apellido2=>'Perez', resultado=>salida); --Farmaceutico OK.
--altaFarmaceutico(P_DNI =>'44927344T', P_centro=>273, P_nombre=>'Jesus',P_apellido1=>'Vega',P_apellido2=>'Perez', resultado=>salida); --Fallo: Farmaceutico existe.
--altaFarmaceutico(P_DNI =>'33601214S', P_centro=>273, P_nombre=>'Perico',P_apellido1=>'de los Palotes',resultado=>salida); --Fallo: clave no encontrada.

-- Test de modFarmaceutico
--modFarmaceutico(P_ID =>1, P_DNI =>'44927344T', P_centro=>273, P_nombre=>'Jesus Fernando',P_apellido1=>'Vega',P_apellido2=>'Perez', resultado=>salida); --Cambiar nombre Farmaceutico 1. OK.
--modFarmaceutico(P_ID =>2, P_DNI =>'44927344T', P_centro=>273, P_nombre=>'Jesus',P_apellido1=>'Vega',P_apellido2=>'Perez', resultado=>salida); --Fallo: El Farmaceutico no existe.

-- Test de bajaFarmaceutico
--bajaFarmaceutico(P_ID =>4, resultado=>salida); --Baja Farmaceutico 1. OK.
--bajaFarmaceutico(P_ID =>5000, resultado=>salida);  --Fallo: El Farmaceutico no existe.

-- Test de altaProveedor
--altaProveedor(P_CIF =>'F23013280', P_denominacion=>'CORENA', resultado=>salida); --Proveedor OK.
--altaProveedor(P_CIF =>'F23013280', P_denominacion=>'CORENA', resultado=>salida); --Fallo: Proveedor existe.

-- Test de modProveedor
--modProveedor(P_ID =>14, P_CIF =>'F23013280',  P_denominacion=>'CORENA S.A', resultado=>salida); --Cambiar nombre Proveedor 14. OK.
--modProveedor(P_ID =>30, P_CIF =>'F23013280',  P_denominacion=>'CORENA', resultado=>salida); --Fallo: El Proveedor no existe.
--modProveedor(P_ID =>14, P_CIF =>'F23013279',  P_denominacion=>'CORENA S.A', resultado=>salida);--fallo: El CIF es de otro proveedor.

-- Test de bajaProveedor
--bajaProveedor(P_ID =>14, resultado=>salida); --Baja Proveedor 14. OK.
--bajaProveedor(P_ID =>5000, resultado=>salida);  --Fallo: El Proveedor no existe.

-- Test de altaPedido
--altaPedido(P_farmaceutico =>1, P_farmaco =>1, P_proveedor =>2 ,P_cantidad =>300, P_fechahora =>SYSDATE, resultado=>salida); --Pedido OK.
--altaPedido(P_farmaceutico =>20, P_farmaco =>1, P_proveedor =>2 ,P_cantidad =>300, P_fechahora =>SYSDATE, resultado=>salida); --Fallo: Cdigo Farmacetico no existe.

-- Test de modPedido
--modPedido(P_ID => 2, P_farmaceutico =>1, P_farmaco =>1, P_proveedor =>3 ,P_cantidad =>200, P_fechahora =>SYSDATE, resultado=>salida);  --Cambiar nombre Proveedor de Pedido 1. OK.
--modPedido(P_ID => 2, P_farmaceutico =>1, P_farmaco =>1, P_proveedor =>30 ,P_cantidad =>300, P_fechahora =>SYSDATE, resultado=>salida); --Fallo: El Proveedor no existe.

-- Test de bajaPedido
--bajaPedido(P_ID =>2, resultado=>salida); --Baja Pedido 2. OK.
--bajaPedido(P_ID =>5000, resultado=>salida);  --Fallo: El Pedido no existe.

-- Test de altaAlergia
--altaAlergia(P_paciente =>1, P_tipo =>3, P_fecha =>SYSDATE, resultado=>salida); --Alergia OK.
--altaAlergia(P_paciente =>5000, P_tipo =>3, P_fecha =>SYSDATE, resultado=>salida); --Fallo: Cdigo Paciente no existe.

-- Test de modAlergia
--modAlergia(P_ID => 1, P_paciente =>1, P_tipo =>5, P_fecha =>SYSDATE, resultado=>salida);  --Cambiar tipo Alergia del Paciente 1. OK.
--modAlergia(P_ID => 1, P_paciente =>5000, P_tipo =>5, P_fecha =>SYSDATE, resultado=>salida); --Fallo: El Paciente no existe.

-- Test de bajaAlergia
--bajaAlergia(P_ID =>1, resultado=>salida); --Baja Alergia 1. OK.
--bajaAlergia(P_ID =>5000, resultado=>salida);  --Fallo: La Alergia no existe.

-- Test de altaPatologia
--altaPatologia(P_paciente =>1, P_diagnostico =>3, P_fechaInicio =>SYSDATE, P_baja =>0, resultado=>salida); --Patologa OK.
--altaPatologia(P_paciente =>5000, P_diagnostico =>3, P_fechaInicio =>SYSDATE, P_baja =>0, resultado=>salida); --Fallo: Cdigo Paciente no existe.

-- Test de modPatologia
--modPatologia(P_ID => 1, P_paciente =>1, P_diagnostico =>4, P_fechaInicio =>SYSDATE, P_baja =>1, resultado=>salida);  --Poner al Paciente 1 de baja. OK.
--modPatologia(P_ID => 1, P_paciente =>5000, P_diagnostico =>4, P_fechaInicio =>SYSDATE, P_baja =>1, resultado=>salida); --Fallo: El Paciente no existe.

-- Test de bajaPatologia
--bajaPatologia(P_ID =>1, resultado=>salida); --Baja Patologia 1. OK.
--bajaPatologia(P_ID =>5000, resultado=>salida);  --Fallo: La Patologia no existe.

-- Test de altaPrueba
--altaPrueba(P_patologia =>1, P_tipo =>3, P_fechaHora =>SYSDATE, registro=>salida); --Patologa OK.
--altaPrueba(P_patologia =>5000, P_tipo =>3, P_fechaHora =>SYSDATE, registro=>salida); --Fallo: Cdigo Patologa no existe.

-- Test de modPrueba
--modPrueba(P_ID => 1, P_patologia =>1, P_tipo =>4, P_fechaHora =>SYSDATE, registro=>salida);  --Cambiar el tipo de Prueba. OK.
--modPrueba(P_ID => 1, P_patologia =>1, P_tipo =>5000, P_fechaHora =>SYSDATE, registro=>salida);  --Fallo: El tipo de Prueba no existe.

-- Test de bajaPrueba
--bajaPrueba(P_ID =>1, registro=>salida); --Baja Prueba 1. OK.
--bajaPrueba(P_ID =>5000, registro=>salida);  --Fallo: La Prueba no existe.

-- Test de altaCita
--altaCita(P_medico =>1, P_enfermero =>1, P_paciente =>1, P_medio =>2, P_patologia =>1, P_fechaHora =>SYSDATE, P_asistencia =>1, P_urgencia => 0, resultado=>salida); --Cita OK.
--altaCita(P_medico =>5000, P_enfermero =>1, P_paciente =>1, P_medio =>2, P_patologia =>1, P_fechaHora =>SYSDATE, P_asistencia =>1, P_urgencia => 0, resultado=>salida); --Fallo: Cdigo Mdico no existe.

-- Test de modCita
--modCita(P_ID => 1, P_medico =>1, P_enfermero =>1, P_paciente =>1, P_medio =>2, P_patologia => 1, P_fechaHora =>SYSDATE, P_asistencia =>1, P_urgencia => 0, resultado=>salida);  --Aade la patologa a la cita del Paciente 1. OK.
--modCita(P_ID => 1, P_medico =>5000, P_enfermero =>1, P_paciente =>1, P_medio =>2, P_patologia => 1, P_fechaHora =>SYSDATE, P_asistencia =>1, P_urgencia => 0, resultado=>salida);  --Fallo: El Mdico no corresponde a esa Cita.

-- Test de bajaCita
--bajaCita(P_ID =>1, resultado=>salida); --Baja Cita 1. OK.
--bajaCita(P_ID =>5000, resultado=>salida);  --Fallo: La Cita no existe.

-- Test de altaTratamiento
--altaTratamiento(P_patologia =>1, P_farmaco =>2, P_medico =>1, P_fechaInicio =>SYSDATE, P_fechaFin =>SYSDATE+7, P_periodicidad =>3, P_cantidad =>1, resultado=>salida); --Tratamiento OK.
--altaPedido(P_farmaceutico =>1, P_farmaco =>189, P_proveedor =>2 ,P_cantidad =>300, P_fechahora =>SYSDATE, resultado=>salida); --alta pedido frmaco con insulina.
--altaAlergia(P_paciente =>1, P_tipo =>110, P_fecha =>SYSDATE, resultado=>salida); --Alta Alergia Insulina (codigo 110) Paciente 1 OK.
--altaTratamiento(P_patologia =>1, P_farmaco =>189, P_medico =>1, P_fechaInicio =>SYSDATE, P_fechaFin =>SYSDATE+7, P_periodicidad =>3, P_cantidad =>1, resultado=>salida); --Fallo: Alta frmaco con insulina (alergia).

-- Test de modTratamiento
--modTratamiento(P_ID =>1, P_patologia =>1, P_medico =>1, P_farmaco =>1, P_fechaInicio =>SYSDATE, P_fechaFin =>SYSDATE+7, P_periodicidad => 2, P_cantidad => 1, resultado=>salida);  --Cambiar la periodicidad del Tratamiento. OK.
--modTratamiento(P_ID =>1, P_patologia =>5000, P_medico =>1, P_farmaco =>1, P_fechaInicio =>SYSDATE, P_fechaFin =>SYSDATE+7, P_periodicidad => 2, P_cantidad => 1, resultado=>salida);  --Fallo: La Patologa no existe.
--modTratamiento(P_ID =>1, P_patologia =>1, P_medico =>1, P_farmaco =>189, P_fechaInicio =>SYSDATE, P_fechaFin =>SYSDATE+7, P_periodicidad => 2, P_cantidad => 1, resultado=>salida); --Fallo: Cambio a frmaco con insulina (alergia).

-- Test de bajaTratamiento
--bajaTratamiento(P_ID =>1, resultado=>salida); --Baja Tratamiento. OK.
--bajaTratamiento(P_ID =>5000, resultado=>salida);  --Fallo: El Tratamiento no existe.

-- Test de altaAdministracion
--altaAdministracion(P_enfermero =>1, P_tratamiento =>1, P_fecha =>SYSDATE, P_periodo =>1, P_cantidad => 1, resultado=>salida); --Administracin Tratamiento OK.
--altaAdministracion(P_enfermero =>5000, P_tratamiento =>1, P_fecha =>SYSDATE, P_periodo =>1, P_cantidad => 1, resultado=>salida); --Fallo: Cdigo Enfermero no existe.
--altaAdministracion(P_enfermero =>1, P_tratamiento =>1, P_fecha =>SYSDATE+10, P_periodo =>1, P_cantidad => 1, resultado=>salida); --Fallo: Acab el Tratamiento.
--altaAdministracion(P_enfermero =>1, P_tratamiento =>1, P_fecha =>SYSDATE, P_periodo =>4, P_cantidad => 1, resultado=>salida); --Fallo: Fuera de periodo.
--altaAdministracion(P_enfermero =>1, P_tratamiento =>1, P_fecha =>SYSDATE, P_periodo =>1, P_cantidad => 50, resultado=>salida); --Fallo: No coincide con la cantidad del Tratamiento.

-- Test de modAdministracion
--modAdministracion(P_ID =>1, P_enfermero =>1, P_tratamiento =>1, P_fecha =>SYSDATE, P_periodo =>2, P_cantidad => 1, resultado=>salida);  -- Modifica el periodo de la Administracin del Tratamiento 1. OK.
--modAdministracion(P_ID =>1, P_enfermero =>5000, P_tratamiento =>1, P_fecha =>SYSDATE, P_periodo =>2, P_cantidad => 1, resultado=>salida);  --Fallo: Cdigo Enfermero no existe.
--modAdministracion(P_ID =>1, P_enfermero =>1, P_tratamiento =>1, P_fecha =>SYSDATE+10, P_periodo =>1, P_cantidad => 1, resultado=>salida); --Fallo: Acab el Tratamiento.
--modAdministracion(P_ID =>1, P_enfermero =>1, P_tratamiento =>1, P_fecha =>SYSDATE, P_periodo =>4, P_cantidad => 1, resultado=>salida); --Fallo: Fuera de periodo.
--modAdministracion(P_ID =>1, P_enfermero =>1, P_tratamiento =>1, P_fecha =>SYSDATE, P_periodo =>1, P_cantidad => 50, resultado=>salida); --Fallo: No coincide con la cantidad del Tratamiento.

-- Test de bajaAdministracion
--bajaAdministracion(P_ID =>2, resultado=>salida); --Baja Administracin Tratamiento 2. OK.
--bajaAdministracion(P_ID =>5000, resultado=>salida);  --Fallo: La Administracin del Tratamiento no existe.

END;