/* 
Script de testeo de los Triggers de la BBDD.
PFC - Base de dades
Autor: Alfredo del Valle Lpez
*/

-- Test de check_pedido_botica
INSERT INTO Pedido (farmaceutico,farmaco,proveedor,cantidad,fechaHora) Values (1,1,1,10,SYSDATE);
UPDATE Pedido SET cantidad = 5 WHERE Pedido.ID = 1;
DELETE Pedido WHERE Pedido.ID = 1;
INSERT INTO Pedido (farmaceutico,farmaco,proveedor,cantidad,fechaHora) Values (1,2,1,1000,SYSDATE);
INSERT INTO Pedido (farmaceutico,farmaco,proveedor,cantidad,fechaHora) Values (1,3,1,-5000,SYSDATE); --Fallo controlado por CONSTRAINT check_stock de Botica
 
-- Test de check_tratamiento_botica
INSERT INTO Patologia (paciente,diagnostico,fechaInicio,baja) Values (1,11,SYSDATE,0);
INSERT INTO Tratamiento (patologia,farmaco,medico,fechaInicio,fechaFin,periodicidad,cantidad) Values (1, 1, 1, SYSDATE, SYSDATE+5,3,1);
INSERT INTO Tratamiento (patologia,farmaco,medico,fechaInicio,fechaFin,periodicidad,cantidad) Values (1, 2, 1, SYSDATE, SYSDATE+3,3,1);
UPDATE Tratamiento SET fechaFin = SYSDATE+3 WHERE Tratamiento.ID = 1;
DELETE Tratamiento WHERE Tratamiento.ID = 1;
INSERT INTO Tratamiento (patologia,farmaco,medico,fechaInicio,fechaFin,periodicidad,cantidad) Values (1, 20, 1, SYSDATE, SYSDATE+10,2,4); --CONSTRAINT check_stock de Botica


-- Test de set_asistencia_cita
INSERT INTO Cita (medico,enfermero,paciente,medio,patologia,fechaHora,asistencia,urgencia) Values (1,1,1,1,1,SYSDATE,0,1);--Hay una urgencia->confirma la asistencia automticamente.
INSERT INTO Cita (medico,enfermero,paciente,medio,patologia,fechaHora,asistencia,urgencia) Values (1,1,1,1,1,SYSDATE,0,0);--No es urgencia no tiene porque actualizar la asistencia (cita previa).