/* 
Script de insercin de datos de lgica de negocio en las tablas de la BD mediante procedimientos. (SEGUNDA PARTE)
PFC - Base de dades
Autor: Alfredo del Valle Lpez
*/

set serveroutput on;
declare 
salida VARCHAR (200);

BEGIN

--Insertar datos Citas
altaCita(P_medico =>14, P_enfermero=>6, P_paciente=>31, P_medio=>5, P_patologia=>70, P_fechaHora=> SYSDATE-10, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>6, P_enfermero=>5, P_paciente=>52, P_medio=>4, P_patologia=>64, P_fechaHora=> SYSDATE-6, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>16, P_enfermero=>19, P_paciente=>147, P_medio=>2, P_patologia=>47, P_fechaHora=> SYSDATE-1, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>19, P_enfermero=>14, P_paciente=>166, P_medio=>3, P_patologia=>86, P_fechaHora=> SYSDATE-2, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>19, P_enfermero=>1, P_paciente=>143, P_medio=>5, P_patologia=>11, P_fechaHora=> SYSDATE-1, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>10, P_enfermero=>8, P_paciente=>148, P_medio=>4, P_patologia=>20, P_fechaHora=> SYSDATE-11, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>11, P_enfermero=>15, P_paciente=>53, P_medio=>1, P_patologia=>84, P_fechaHora=> SYSDATE-13, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>16, P_enfermero=>1, P_paciente=>113, P_medio=>1, P_patologia=>21, P_fechaHora=> SYSDATE-5, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>9, P_enfermero=>15, P_paciente=>19, P_medio=>3, P_patologia=>91, P_fechaHora=> SYSDATE-8, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>17, P_enfermero=>18, P_paciente=>110, P_medio=>5, P_patologia=>93, P_fechaHora=> SYSDATE-3, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>19, P_enfermero=>6, P_paciente=>110, P_medio=>2, P_patologia=>46, P_fechaHora=> SYSDATE-9, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>14, P_enfermero=>18, P_paciente=>35, P_medio=>1, P_patologia=>26, P_fechaHora=> SYSDATE-13, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>12, P_enfermero=>2, P_paciente=>52, P_medio=>4, P_patologia=>21, P_fechaHora=> SYSDATE-14, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>9, P_enfermero=>16, P_paciente=>121, P_medio=>1, P_patologia=>20, P_fechaHora=> SYSDATE-11, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>17, P_enfermero=>6, P_paciente=>76, P_medio=>3, P_patologia=>95, P_fechaHora=> SYSDATE-2, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>13, P_enfermero=>14, P_paciente=>101, P_medio=>3, P_patologia=>12, P_fechaHora=> SYSDATE-12, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>4, P_enfermero=>14, P_paciente=>77, P_medio=>4, P_patologia=>73, P_fechaHora=> SYSDATE-14, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>7, P_enfermero=>19, P_paciente=>48, P_medio=>2, P_patologia=>2, P_fechaHora=> SYSDATE-6, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>5, P_enfermero=>18, P_paciente=>31, P_medio=>3, P_patologia=>59, P_fechaHora=> SYSDATE-13, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>16, P_enfermero=>16, P_paciente=>160, P_medio=>4, P_patologia=>99, P_fechaHora=> SYSDATE-14, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>14, P_enfermero=>17, P_paciente=>135, P_medio=>3, P_patologia=>50, P_fechaHora=> SYSDATE-11, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>18, P_enfermero=>18, P_paciente=>72, P_medio=>5, P_patologia=>52, P_fechaHora=> SYSDATE-13, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>5, P_enfermero=>2, P_paciente=>6, P_medio=>5, P_patologia=>83, P_fechaHora=> SYSDATE-13, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>5, P_enfermero=>7, P_paciente=>91, P_medio=>3, P_patologia=>43, P_fechaHora=> SYSDATE-13, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>14, P_enfermero=>14, P_paciente=>84, P_medio=>2, P_patologia=>69, P_fechaHora=> SYSDATE-1, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>6, P_enfermero=>17, P_paciente=>184, P_medio=>5, P_patologia=>98, P_fechaHora=> SYSDATE-2, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>3, P_enfermero=>13, P_paciente=>159, P_medio=>2, P_patologia=>73, P_fechaHora=> SYSDATE-9, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>8, P_enfermero=>16, P_paciente=>29, P_medio=>3, P_patologia=>97, P_fechaHora=> SYSDATE-2, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>5, P_enfermero=>9, P_paciente=>39, P_medio=>5, P_patologia=>53, P_fechaHora=> SYSDATE-5, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>15, P_enfermero=>15, P_paciente=>177, P_medio=>2, P_patologia=>76, P_fechaHora=> SYSDATE-2, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>16, P_enfermero=>3, P_paciente=>106, P_medio=>4, P_patologia=>50, P_fechaHora=> SYSDATE-12, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>1, P_enfermero=>10, P_paciente=>131, P_medio=>5, P_patologia=>58, P_fechaHora=> SYSDATE-3, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>2, P_enfermero=>10, P_paciente=>55, P_medio=>1, P_patologia=>24, P_fechaHora=> SYSDATE-11, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>7, P_enfermero=>10, P_paciente=>135, P_medio=>1, P_patologia=>83, P_fechaHora=> SYSDATE-9, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>18, P_enfermero=>11, P_paciente=>131, P_medio=>2, P_patologia=>78, P_fechaHora=> SYSDATE-5, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>6, P_enfermero=>5, P_paciente=>52, P_medio=>3, P_patologia=>19, P_fechaHora=> SYSDATE-6, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>17, P_enfermero=>4, P_paciente=>115, P_medio=>1, P_patologia=>11, P_fechaHora=> SYSDATE-12, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>9, P_enfermero=>16, P_paciente=>178, P_medio=>5, P_patologia=>21, P_fechaHora=> SYSDATE-8, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>4, P_enfermero=>3, P_paciente=>74, P_medio=>5, P_patologia=>36, P_fechaHora=> SYSDATE-12, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>18, P_enfermero=>15, P_paciente=>99, P_medio=>4, P_patologia=>42, P_fechaHora=> SYSDATE-2, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>1, P_enfermero=>3, P_paciente=>93, P_medio=>5, P_patologia=>52, P_fechaHora=> SYSDATE-1, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>10, P_enfermero=>8, P_paciente=>117, P_medio=>3, P_patologia=>49, P_fechaHora=> SYSDATE-6, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>13, P_enfermero=>1, P_paciente=>72, P_medio=>4, P_patologia=>98, P_fechaHora=> SYSDATE-13, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>11, P_enfermero=>16, P_paciente=>130, P_medio=>4, P_patologia=>98, P_fechaHora=> SYSDATE-3, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>12, P_enfermero=>8, P_paciente=>16, P_medio=>3, P_patologia=>11, P_fechaHora=> SYSDATE-14, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>3, P_enfermero=>19, P_paciente=>131, P_medio=>2, P_patologia=>13, P_fechaHora=> SYSDATE-10, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>19, P_enfermero=>10, P_paciente=>146, P_medio=>2, P_patologia=>19, P_fechaHora=> SYSDATE-1, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>11, P_enfermero=>17, P_paciente=>169, P_medio=>4, P_patologia=>41, P_fechaHora=> SYSDATE-10, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>12, P_enfermero=>16, P_paciente=>119, P_medio=>3, P_patologia=>74, P_fechaHora=> SYSDATE-9, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>12, P_enfermero=>18, P_paciente=>101, P_medio=>5, P_patologia=>41, P_fechaHora=> SYSDATE-7, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>8, P_enfermero=>6, P_paciente=>130, P_medio=>4, P_patologia=>98, P_fechaHora=> SYSDATE-1, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>6, P_enfermero=>1, P_paciente=>85, P_medio=>1, P_patologia=>45, P_fechaHora=> SYSDATE-4, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>15, P_enfermero=>11, P_paciente=>73, P_medio=>4, P_patologia=>92, P_fechaHora=> SYSDATE-4, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>9, P_enfermero=>19, P_paciente=>24, P_medio=>5, P_patologia=>84, P_fechaHora=> SYSDATE-14, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>3, P_enfermero=>17, P_paciente=>117, P_medio=>2, P_patologia=>73, P_fechaHora=> SYSDATE-14, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>18, P_enfermero=>8, P_paciente=>77, P_medio=>4, P_patologia=>12, P_fechaHora=> SYSDATE-8, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>5, P_enfermero=>10, P_paciente=>9, P_medio=>4, P_patologia=>66, P_fechaHora=> SYSDATE-5, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>15, P_enfermero=>19, P_paciente=>115, P_medio=>1, P_patologia=>5, P_fechaHora=> SYSDATE-5, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>1, P_enfermero=>11, P_paciente=>50, P_medio=>5, P_patologia=>78, P_fechaHora=> SYSDATE-14, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>10, P_enfermero=>3, P_paciente=>49, P_medio=>2, P_patologia=>61, P_fechaHora=> SYSDATE-10, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>4, P_enfermero=>17, P_paciente=>77, P_medio=>5, P_patologia=>46, P_fechaHora=> SYSDATE-2, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>15, P_enfermero=>4, P_paciente=>164, P_medio=>4, P_patologia=>44, P_fechaHora=> SYSDATE-6, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>4, P_enfermero=>8, P_paciente=>75, P_medio=>3, P_patologia=>23, P_fechaHora=> SYSDATE-7, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>19, P_enfermero=>10, P_paciente=>186, P_medio=>2, P_patologia=>68, P_fechaHora=> SYSDATE-14, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>14, P_enfermero=>10, P_paciente=>186, P_medio=>4, P_patologia=>65, P_fechaHora=> SYSDATE-11, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>4, P_enfermero=>3, P_paciente=>180, P_medio=>4, P_patologia=>29, P_fechaHora=> SYSDATE-10, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>2, P_enfermero=>2, P_paciente=>145, P_medio=>4, P_patologia=>93, P_fechaHora=> SYSDATE-11, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>2, P_enfermero=>16, P_paciente=>25, P_medio=>1, P_patologia=>72, P_fechaHora=> SYSDATE-3, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>15, P_enfermero=>14, P_paciente=>38, P_medio=>5, P_patologia=>95, P_fechaHora=> SYSDATE-5, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>2, P_enfermero=>18, P_paciente=>54, P_medio=>5, P_patologia=>30, P_fechaHora=> SYSDATE-7, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>2, P_enfermero=>11, P_paciente=>88, P_medio=>4, P_patologia=>99, P_fechaHora=> SYSDATE-4, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>12, P_enfermero=>8, P_paciente=>126, P_medio=>4, P_patologia=>99, P_fechaHora=> SYSDATE-5, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>17, P_enfermero=>12, P_paciente=>14, P_medio=>1, P_patologia=>26, P_fechaHora=> SYSDATE-5, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>7, P_enfermero=>10, P_paciente=>76, P_medio=>2, P_patologia=>55, P_fechaHora=> SYSDATE-6, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>2, P_enfermero=>3, P_paciente=>129, P_medio=>4, P_patologia=>30, P_fechaHora=> SYSDATE-7, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>18, P_enfermero=>10, P_paciente=>179, P_medio=>2, P_patologia=>59, P_fechaHora=> SYSDATE-11, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>2, P_enfermero=>2, P_paciente=>139, P_medio=>5, P_patologia=>37, P_fechaHora=> SYSDATE-10, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>7, P_enfermero=>17, P_paciente=>82, P_medio=>3, P_patologia=>44, P_fechaHora=> SYSDATE-4, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>11, P_enfermero=>9, P_paciente=>47, P_medio=>4, P_patologia=>54, P_fechaHora=> SYSDATE-10, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>16, P_enfermero=>8, P_paciente=>189, P_medio=>1, P_patologia=>99, P_fechaHora=> SYSDATE-11, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>8, P_enfermero=>4, P_paciente=>165, P_medio=>1, P_patologia=>18, P_fechaHora=> SYSDATE-12, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>19, P_enfermero=>10, P_paciente=>122, P_medio=>5, P_patologia=>57, P_fechaHora=> SYSDATE-6, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>1, P_enfermero=>16, P_paciente=>47, P_medio=>4, P_patologia=>75, P_fechaHora=> SYSDATE-8, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>19, P_enfermero=>6, P_paciente=>55, P_medio=>3, P_patologia=>27, P_fechaHora=> SYSDATE-8, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>17, P_enfermero=>14, P_paciente=>163, P_medio=>3, P_patologia=>11, P_fechaHora=> SYSDATE-6, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>4, P_enfermero=>8, P_paciente=>191, P_medio=>1, P_patologia=>78, P_fechaHora=> SYSDATE-12, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>14, P_enfermero=>6, P_paciente=>69, P_medio=>1, P_patologia=>33, P_fechaHora=> SYSDATE-14, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>16, P_enfermero=>11, P_paciente=>78, P_medio=>1, P_patologia=>40, P_fechaHora=> SYSDATE-5, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>15, P_enfermero=>12, P_paciente=>33, P_medio=>5, P_patologia=>8, P_fechaHora=> SYSDATE-12, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>7, P_enfermero=>16, P_paciente=>70, P_medio=>2, P_patologia=>47, P_fechaHora=> SYSDATE-2, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>9, P_enfermero=>3, P_paciente=>32, P_medio=>5, P_patologia=>52, P_fechaHora=> SYSDATE-8, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>12, P_enfermero=>6, P_paciente=>79, P_medio=>3, P_patologia=>69, P_fechaHora=> SYSDATE-1, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>12, P_enfermero=>13, P_paciente=>17, P_medio=>5, P_patologia=>30, P_fechaHora=> SYSDATE-7, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>8, P_enfermero=>17, P_paciente=>119, P_medio=>1, P_patologia=>93, P_fechaHora=> SYSDATE-12, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>18, P_enfermero=>5, P_paciente=>38, P_medio=>5, P_patologia=>11, P_fechaHora=> SYSDATE-2, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>8, P_enfermero=>12, P_paciente=>121, P_medio=>1, P_patologia=>25, P_fechaHora=> SYSDATE-9, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>4, P_enfermero=>14, P_paciente=>117, P_medio=>3, P_patologia=>77, P_fechaHora=> SYSDATE-4, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>10, P_enfermero=>15, P_paciente=>108, P_medio=>2, P_patologia=>79, P_fechaHora=> SYSDATE-13, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>18, P_enfermero=>13, P_paciente=>65, P_medio=>5, P_patologia=>56, P_fechaHora=> SYSDATE-8, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>8, P_enfermero=>5, P_paciente=>57, P_medio=>5, P_patologia=>77, P_fechaHora=> SYSDATE-3, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>16, P_enfermero=>17, P_paciente=>175, P_medio=>2, P_patologia=>86, P_fechaHora=> SYSDATE-6, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>6, P_enfermero=>19, P_paciente=>81, P_medio=>2, P_patologia=>1, P_fechaHora=> SYSDATE-14, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>10, P_enfermero=>3, P_paciente=>177, P_medio=>4, P_patologia=>47, P_fechaHora=> SYSDATE-9, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>16, P_enfermero=>11, P_paciente=>49, P_medio=>2, P_patologia=>5, P_fechaHora=> SYSDATE-12, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>8, P_enfermero=>18, P_paciente=>156, P_medio=>5, P_patologia=>40, P_fechaHora=> SYSDATE-2, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>6, P_enfermero=>7, P_paciente=>84, P_medio=>4, P_patologia=>46, P_fechaHora=> SYSDATE-7, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>18, P_enfermero=>19, P_paciente=>40, P_medio=>1, P_patologia=>53, P_fechaHora=> SYSDATE-7, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>4, P_enfermero=>9, P_paciente=>155, P_medio=>3, P_patologia=>23, P_fechaHora=> SYSDATE-6, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>6, P_enfermero=>15, P_paciente=>1, P_medio=>4, P_patologia=>8, P_fechaHora=> SYSDATE-6, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>6, P_enfermero=>6, P_paciente=>162, P_medio=>2, P_patologia=>48, P_fechaHora=> SYSDATE-2, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>15, P_enfermero=>6, P_paciente=>62, P_medio=>2, P_patologia=>35, P_fechaHora=> SYSDATE-7, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>4, P_enfermero=>12, P_paciente=>62, P_medio=>4, P_patologia=>52, P_fechaHora=> SYSDATE-8, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>12, P_enfermero=>5, P_paciente=>26, P_medio=>1, P_patologia=>59, P_fechaHora=> SYSDATE-10, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>6, P_enfermero=>15, P_paciente=>137, P_medio=>5, P_patologia=>91, P_fechaHora=> SYSDATE-5, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>10, P_enfermero=>10, P_paciente=>164, P_medio=>1, P_patologia=>86, P_fechaHora=> SYSDATE-13, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>11, P_enfermero=>7, P_paciente=>188, P_medio=>1, P_patologia=>21, P_fechaHora=> SYSDATE-7, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>15, P_enfermero=>18, P_paciente=>182, P_medio=>5, P_patologia=>69, P_fechaHora=> SYSDATE-6, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>14, P_enfermero=>13, P_paciente=>57, P_medio=>2, P_patologia=>31, P_fechaHora=> SYSDATE-1, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>11, P_enfermero=>3, P_paciente=>127, P_medio=>1, P_patologia=>19, P_fechaHora=> SYSDATE-5, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>10, P_enfermero=>18, P_paciente=>116, P_medio=>5, P_patologia=>3, P_fechaHora=> SYSDATE-11, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>9, P_enfermero=>16, P_paciente=>170, P_medio=>1, P_patologia=>60, P_fechaHora=> SYSDATE-4, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>16, P_enfermero=>5, P_paciente=>182, P_medio=>5, P_patologia=>9, P_fechaHora=> SYSDATE-4, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>16, P_enfermero=>8, P_paciente=>52, P_medio=>5, P_patologia=>60, P_fechaHora=> SYSDATE-2, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>19, P_enfermero=>17, P_paciente=>11, P_medio=>1, P_patologia=>95, P_fechaHora=> SYSDATE-10, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>10, P_enfermero=>1, P_paciente=>33, P_medio=>5, P_patologia=>95, P_fechaHora=> SYSDATE-12, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>6, P_enfermero=>14, P_paciente=>30, P_medio=>3, P_patologia=>33, P_fechaHora=> SYSDATE-4, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>3, P_enfermero=>17, P_paciente=>16, P_medio=>4, P_patologia=>72, P_fechaHora=> SYSDATE-14, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>11, P_enfermero=>10, P_paciente=>56, P_medio=>5, P_patologia=>35, P_fechaHora=> SYSDATE-14, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>1, P_enfermero=>14, P_paciente=>39, P_medio=>4, P_patologia=>28, P_fechaHora=> SYSDATE-10, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>14, P_enfermero=>19, P_paciente=>54, P_medio=>5, P_patologia=>21, P_fechaHora=> SYSDATE-4, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>2, P_enfermero=>1, P_paciente=>85, P_medio=>2, P_patologia=>45, P_fechaHora=> SYSDATE-7, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>9, P_enfermero=>6, P_paciente=>6, P_medio=>3, P_patologia=>92, P_fechaHora=> SYSDATE-5, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>2, P_enfermero=>7, P_paciente=>52, P_medio=>4, P_patologia=>57, P_fechaHora=> SYSDATE-9, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>9, P_enfermero=>19, P_paciente=>7, P_medio=>5, P_patologia=>58, P_fechaHora=> SYSDATE-11, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>1, P_enfermero=>18, P_paciente=>109, P_medio=>5, P_patologia=>66, P_fechaHora=> SYSDATE-4, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>19, P_enfermero=>11, P_paciente=>11, P_medio=>5, P_patologia=>45, P_fechaHora=> SYSDATE-2, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>10, P_enfermero=>13, P_paciente=>9, P_medio=>1, P_patologia=>28, P_fechaHora=> SYSDATE-8, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>17, P_enfermero=>14, P_paciente=>113, P_medio=>5, P_patologia=>25, P_fechaHora=> SYSDATE-11, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>17, P_enfermero=>2, P_paciente=>5, P_medio=>3, P_patologia=>79, P_fechaHora=> SYSDATE-5, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>3, P_enfermero=>1, P_paciente=>116, P_medio=>4, P_patologia=>7, P_fechaHora=> SYSDATE-4, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>10, P_enfermero=>7, P_paciente=>184, P_medio=>4, P_patologia=>67, P_fechaHora=> SYSDATE-12, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>10, P_enfermero=>8, P_paciente=>102, P_medio=>5, P_patologia=>91, P_fechaHora=> SYSDATE-5, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>19, P_enfermero=>18, P_paciente=>182, P_medio=>3, P_patologia=>40, P_fechaHora=> SYSDATE-2, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>19, P_enfermero=>7, P_paciente=>185, P_medio=>2, P_patologia=>9, P_fechaHora=> SYSDATE-11, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>2, P_enfermero=>19, P_paciente=>133, P_medio=>4, P_patologia=>4, P_fechaHora=> SYSDATE-12, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>10, P_enfermero=>7, P_paciente=>129, P_medio=>5, P_patologia=>93, P_fechaHora=> SYSDATE-10, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>15, P_enfermero=>16, P_paciente=>37, P_medio=>3, P_patologia=>61, P_fechaHora=> SYSDATE-7, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>10, P_enfermero=>10, P_paciente=>12, P_medio=>3, P_patologia=>6, P_fechaHora=> SYSDATE-13, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>5, P_enfermero=>1, P_paciente=>143, P_medio=>3, P_patologia=>9, P_fechaHora=> SYSDATE-1, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>1, P_enfermero=>15, P_paciente=>152, P_medio=>1, P_patologia=>20, P_fechaHora=> SYSDATE-6, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>15, P_enfermero=>7, P_paciente=>72, P_medio=>3, P_patologia=>93, P_fechaHora=> SYSDATE-11, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>10, P_enfermero=>8, P_paciente=>41, P_medio=>5, P_patologia=>24, P_fechaHora=> SYSDATE-12, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>8, P_enfermero=>9, P_paciente=>6, P_medio=>1, P_patologia=>70, P_fechaHora=> SYSDATE-9, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>18, P_enfermero=>1, P_paciente=>40, P_medio=>4, P_patologia=>68, P_fechaHora=> SYSDATE-6, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>3, P_enfermero=>4, P_paciente=>167, P_medio=>4, P_patologia=>96, P_fechaHora=> SYSDATE-13, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>15, P_enfermero=>16, P_paciente=>16, P_medio=>5, P_patologia=>49, P_fechaHora=> SYSDATE-7, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>5, P_enfermero=>14, P_paciente=>22, P_medio=>3, P_patologia=>47, P_fechaHora=> SYSDATE-10, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>1, P_enfermero=>13, P_paciente=>32, P_medio=>4, P_patologia=>47, P_fechaHora=> SYSDATE-10, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>3, P_enfermero=>9, P_paciente=>109, P_medio=>5, P_patologia=>28, P_fechaHora=> SYSDATE-11, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>9, P_enfermero=>12, P_paciente=>77, P_medio=>2, P_patologia=>38, P_fechaHora=> SYSDATE-10, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>8, P_enfermero=>18, P_paciente=>59, P_medio=>4, P_patologia=>28, P_fechaHora=> SYSDATE-4, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>11, P_enfermero=>6, P_paciente=>166, P_medio=>3, P_patologia=>65, P_fechaHora=> SYSDATE-7, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>14, P_enfermero=>9, P_paciente=>132, P_medio=>2, P_patologia=>32, P_fechaHora=> SYSDATE-14, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>16, P_enfermero=>9, P_paciente=>139, P_medio=>2, P_patologia=>99, P_fechaHora=> SYSDATE-14, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>8, P_enfermero=>3, P_paciente=>182, P_medio=>2, P_patologia=>94, P_fechaHora=> SYSDATE-3, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>7, P_enfermero=>16, P_paciente=>133, P_medio=>1, P_patologia=>89, P_fechaHora=> SYSDATE-6, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>4, P_enfermero=>18, P_paciente=>69, P_medio=>2, P_patologia=>13, P_fechaHora=> SYSDATE-10, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>2, P_enfermero=>7, P_paciente=>117, P_medio=>5, P_patologia=>90, P_fechaHora=> SYSDATE-9, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>4, P_enfermero=>10, P_paciente=>126, P_medio=>5, P_patologia=>33, P_fechaHora=> SYSDATE-14, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>8, P_enfermero=>14, P_paciente=>59, P_medio=>4, P_patologia=>19, P_fechaHora=> SYSDATE-11, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>10, P_enfermero=>11, P_paciente=>55, P_medio=>4, P_patologia=>6, P_fechaHora=> SYSDATE-14, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>12, P_enfermero=>19, P_paciente=>174, P_medio=>1, P_patologia=>34, P_fechaHora=> SYSDATE-14, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>7, P_enfermero=>16, P_paciente=>32, P_medio=>2, P_patologia=>64, P_fechaHora=> SYSDATE-9, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>8, P_enfermero=>16, P_paciente=>36, P_medio=>3, P_patologia=>38, P_fechaHora=> SYSDATE-2, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>6, P_enfermero=>13, P_paciente=>11, P_medio=>1, P_patologia=>7, P_fechaHora=> SYSDATE-4, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>19, P_enfermero=>19, P_paciente=>42, P_medio=>1, P_patologia=>34, P_fechaHora=> SYSDATE-13, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>17, P_enfermero=>8, P_paciente=>62, P_medio=>5, P_patologia=>60, P_fechaHora=> SYSDATE-4, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>10, P_enfermero=>2, P_paciente=>61, P_medio=>2, P_patologia=>54, P_fechaHora=> SYSDATE-11, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>5, P_enfermero=>5, P_paciente=>58, P_medio=>3, P_patologia=>35, P_fechaHora=> SYSDATE-13, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>3, P_enfermero=>11, P_paciente=>155, P_medio=>1, P_patologia=>74, P_fechaHora=> SYSDATE-3, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>9, P_enfermero=>17, P_paciente=>7, P_medio=>3, P_patologia=>73, P_fechaHora=> SYSDATE-3, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>1, P_enfermero=>12, P_paciente=>94, P_medio=>4, P_patologia=>46, P_fechaHora=> SYSDATE-11, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>9, P_enfermero=>5, P_paciente=>59, P_medio=>1, P_patologia=>85, P_fechaHora=> SYSDATE-4, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>8, P_enfermero=>14, P_paciente=>105, P_medio=>5, P_patologia=>13, P_fechaHora=> SYSDATE-4, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>12, P_enfermero=>10, P_paciente=>20, P_medio=>3, P_patologia=>14, P_fechaHora=> SYSDATE-5, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>7, P_enfermero=>12, P_paciente=>152, P_medio=>3, P_patologia=>91, P_fechaHora=> SYSDATE-7, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>14, P_enfermero=>17, P_paciente=>71, P_medio=>3, P_patologia=>11, P_fechaHora=> SYSDATE-8, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>5, P_enfermero=>16, P_paciente=>96, P_medio=>3, P_patologia=>37, P_fechaHora=> SYSDATE-10, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>16, P_enfermero=>16, P_paciente=>133, P_medio=>1, P_patologia=>21, P_fechaHora=> SYSDATE-12, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>13, P_enfermero=>15, P_paciente=>10, P_medio=>2, P_patologia=>81, P_fechaHora=> SYSDATE-4, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>8, P_enfermero=>5, P_paciente=>124, P_medio=>1, P_patologia=>54, P_fechaHora=> SYSDATE-3, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>9, P_enfermero=>15, P_paciente=>177, P_medio=>2, P_patologia=>95, P_fechaHora=> SYSDATE-8, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>5, P_enfermero=>3, P_paciente=>81, P_medio=>4, P_patologia=>29, P_fechaHora=> SYSDATE-3, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>17, P_enfermero=>11, P_paciente=>184, P_medio=>1, P_patologia=>55, P_fechaHora=> SYSDATE-10, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>3, P_enfermero=>11, P_paciente=>126, P_medio=>3, P_patologia=>19, P_fechaHora=> SYSDATE-13, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>3, P_enfermero=>15, P_paciente=>123, P_medio=>2, P_patologia=>17, P_fechaHora=> SYSDATE-6, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>2, P_enfermero=>17, P_paciente=>89, P_medio=>4, P_patologia=>41, P_fechaHora=> SYSDATE-6, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>16, P_enfermero=>2, P_paciente=>133, P_medio=>2, P_patologia=>77, P_fechaHora=> SYSDATE-7, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>1, P_enfermero=>18, P_paciente=>150, P_medio=>3, P_patologia=>55, P_fechaHora=> SYSDATE-10, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>6, P_enfermero=>14, P_paciente=>61, P_medio=>5, P_patologia=>96, P_fechaHora=> SYSDATE-7, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>13, P_enfermero=>6, P_paciente=>91, P_medio=>5, P_patologia=>54, P_fechaHora=> SYSDATE-10, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>15, P_enfermero=>16, P_paciente=>18, P_medio=>4, P_patologia=>63, P_fechaHora=> SYSDATE-13, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>7, P_enfermero=>11, P_paciente=>146, P_medio=>3, P_patologia=>63, P_fechaHora=> SYSDATE-7, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>17, P_enfermero=>11, P_paciente=>165, P_medio=>1, P_patologia=>71, P_fechaHora=> SYSDATE-10, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>15, P_enfermero=>18, P_paciente=>173, P_medio=>5, P_patologia=>63, P_fechaHora=> SYSDATE-3, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>14, P_enfermero=>14, P_paciente=>74, P_medio=>5, P_patologia=>99, P_fechaHora=> SYSDATE-8, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>5, P_enfermero=>19, P_paciente=>169, P_medio=>2, P_patologia=>20, P_fechaHora=> SYSDATE-6, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>11, P_enfermero=>2, P_paciente=>168, P_medio=>3, P_patologia=>19, P_fechaHora=> SYSDATE-13, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>14, P_enfermero=>9, P_paciente=>74, P_medio=>3, P_patologia=>77, P_fechaHora=> SYSDATE-8, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>9, P_enfermero=>1, P_paciente=>184, P_medio=>4, P_patologia=>77, P_fechaHora=> SYSDATE-3, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>1, P_enfermero=>14, P_paciente=>77, P_medio=>4, P_patologia=>90, P_fechaHora=> SYSDATE-1, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>11, P_enfermero=>2, P_paciente=>42, P_medio=>3, P_patologia=>5, P_fechaHora=> SYSDATE-1, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>3, P_enfermero=>1, P_paciente=>46, P_medio=>2, P_patologia=>63, P_fechaHora=> SYSDATE-1, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>2, P_enfermero=>17, P_paciente=>80, P_medio=>3, P_patologia=>86, P_fechaHora=> SYSDATE-8, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>9, P_enfermero=>8, P_paciente=>158, P_medio=>5, P_patologia=>65, P_fechaHora=> SYSDATE-5, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>3, P_enfermero=>11, P_paciente=>66, P_medio=>5, P_patologia=>81, P_fechaHora=> SYSDATE-12, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>10, P_enfermero=>4, P_paciente=>88, P_medio=>2, P_patologia=>45, P_fechaHora=> SYSDATE-12, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>18, P_enfermero=>15, P_paciente=>120, P_medio=>2, P_patologia=>67, P_fechaHora=> SYSDATE-7, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>10, P_enfermero=>10, P_paciente=>12, P_medio=>4, P_patologia=>34, P_fechaHora=> SYSDATE-4, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>16, P_enfermero=>4, P_paciente=>94, P_medio=>4, P_patologia=>19, P_fechaHora=> SYSDATE-10, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>19, P_enfermero=>18, P_paciente=>118, P_medio=>2, P_patologia=>89, P_fechaHora=> SYSDATE-5, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>10, P_enfermero=>6, P_paciente=>170, P_medio=>3, P_patologia=>45, P_fechaHora=> SYSDATE-7, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>15, P_enfermero=>16, P_paciente=>24, P_medio=>3, P_patologia=>2, P_fechaHora=> SYSDATE-2, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>9, P_enfermero=>5, P_paciente=>34, P_medio=>4, P_patologia=>88, P_fechaHora=> SYSDATE-5, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>4, P_enfermero=>12, P_paciente=>102, P_medio=>4, P_patologia=>48, P_fechaHora=> SYSDATE-1, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>3, P_enfermero=>18, P_paciente=>28, P_medio=>4, P_patologia=>95, P_fechaHora=> SYSDATE-13, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>17, P_enfermero=>18, P_paciente=>44, P_medio=>1, P_patologia=>75, P_fechaHora=> SYSDATE-10, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>13, P_enfermero=>9, P_paciente=>183, P_medio=>4, P_patologia=>1, P_fechaHora=> SYSDATE-12, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>18, P_enfermero=>4, P_paciente=>41, P_medio=>5, P_patologia=>51, P_fechaHora=> SYSDATE-2, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>3, P_enfermero=>1, P_paciente=>173, P_medio=>2, P_patologia=>65, P_fechaHora=> SYSDATE-10, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>11, P_enfermero=>17, P_paciente=>74, P_medio=>3, P_patologia=>75, P_fechaHora=> SYSDATE-11, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>3, P_enfermero=>19, P_paciente=>25, P_medio=>1, P_patologia=>17, P_fechaHora=> SYSDATE-7, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>7, P_enfermero=>15, P_paciente=>127, P_medio=>4, P_patologia=>76, P_fechaHora=> SYSDATE-14, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>10, P_enfermero=>9, P_paciente=>147, P_medio=>1, P_patologia=>98, P_fechaHora=> SYSDATE-10, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>2, P_enfermero=>5, P_paciente=>179, P_medio=>4, P_patologia=>11, P_fechaHora=> SYSDATE-12, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>17, P_enfermero=>9, P_paciente=>134, P_medio=>2, P_patologia=>49, P_fechaHora=> SYSDATE-2, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>7, P_enfermero=>17, P_paciente=>163, P_medio=>3, P_patologia=>46, P_fechaHora=> SYSDATE-13, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>16, P_enfermero=>15, P_paciente=>114, P_medio=>1, P_patologia=>17, P_fechaHora=> SYSDATE-6, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>14, P_enfermero=>14, P_paciente=>104, P_medio=>1, P_patologia=>10, P_fechaHora=> SYSDATE-12, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>11, P_enfermero=>2, P_paciente=>113, P_medio=>3, P_patologia=>1, P_fechaHora=> SYSDATE-3, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>16, P_enfermero=>11, P_paciente=>143, P_medio=>1, P_patologia=>47, P_fechaHora=> SYSDATE-6, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>16, P_enfermero=>18, P_paciente=>73, P_medio=>5, P_patologia=>49, P_fechaHora=> SYSDATE-1, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>17, P_enfermero=>7, P_paciente=>41, P_medio=>4, P_patologia=>34, P_fechaHora=> SYSDATE-12, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>7, P_enfermero=>17, P_paciente=>73, P_medio=>1, P_patologia=>54, P_fechaHora=> SYSDATE-6, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>6, P_enfermero=>7, P_paciente=>19, P_medio=>2, P_patologia=>25, P_fechaHora=> SYSDATE-4, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>3, P_enfermero=>6, P_paciente=>61, P_medio=>3, P_patologia=>21, P_fechaHora=> SYSDATE-13, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>12, P_enfermero=>9, P_paciente=>104, P_medio=>5, P_patologia=>92, P_fechaHora=> SYSDATE-2, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>8, P_enfermero=>8, P_paciente=>105, P_medio=>2, P_patologia=>8, P_fechaHora=> SYSDATE-6, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>6, P_enfermero=>16, P_paciente=>108, P_medio=>2, P_patologia=>58, P_fechaHora=> SYSDATE-12, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>9, P_enfermero=>17, P_paciente=>164, P_medio=>4, P_patologia=>59, P_fechaHora=> SYSDATE-11, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>17, P_enfermero=>15, P_paciente=>7, P_medio=>5, P_patologia=>74, P_fechaHora=> SYSDATE-11, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>6, P_enfermero=>10, P_paciente=>84, P_medio=>2, P_patologia=>61, P_fechaHora=> SYSDATE-9, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>18, P_enfermero=>7, P_paciente=>175, P_medio=>5, P_patologia=>52, P_fechaHora=> SYSDATE-8, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>3, P_enfermero=>3, P_paciente=>57, P_medio=>4, P_patologia=>16, P_fechaHora=> SYSDATE-1, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>12, P_enfermero=>8, P_paciente=>98, P_medio=>2, P_patologia=>19, P_fechaHora=> SYSDATE-4, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>6, P_enfermero=>15, P_paciente=>122, P_medio=>4, P_patologia=>99, P_fechaHora=> SYSDATE-3, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>8, P_enfermero=>5, P_paciente=>130, P_medio=>5, P_patologia=>61, P_fechaHora=> SYSDATE-7, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>6, P_enfermero=>4, P_paciente=>72, P_medio=>1, P_patologia=>88, P_fechaHora=> SYSDATE-6, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>15, P_enfermero=>17, P_paciente=>5, P_medio=>5, P_patologia=>64, P_fechaHora=> SYSDATE-5, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>8, P_enfermero=>16, P_paciente=>168, P_medio=>4, P_patologia=>57, P_fechaHora=> SYSDATE-10, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>19, P_enfermero=>10, P_paciente=>60, P_medio=>3, P_patologia=>61, P_fechaHora=> SYSDATE-12, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>19, P_enfermero=>1, P_paciente=>75, P_medio=>2, P_patologia=>70, P_fechaHora=> SYSDATE-12, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>14, P_enfermero=>5, P_paciente=>143, P_medio=>5, P_patologia=>49, P_fechaHora=> SYSDATE-5, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>12, P_enfermero=>9, P_paciente=>36, P_medio=>1, P_patologia=>84, P_fechaHora=> SYSDATE-13, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>14, P_enfermero=>6, P_paciente=>22, P_medio=>1, P_patologia=>29, P_fechaHora=> SYSDATE-3, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>19, P_enfermero=>13, P_paciente=>171, P_medio=>3, P_patologia=>51, P_fechaHora=> SYSDATE-11, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>6, P_enfermero=>14, P_paciente=>133, P_medio=>3, P_patologia=>49, P_fechaHora=> SYSDATE-2, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>14, P_enfermero=>3, P_paciente=>146, P_medio=>4, P_patologia=>10, P_fechaHora=> SYSDATE-3, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>10, P_enfermero=>13, P_paciente=>7, P_medio=>5, P_patologia=>46, P_fechaHora=> SYSDATE-1, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>10, P_enfermero=>14, P_paciente=>180, P_medio=>5, P_patologia=>56, P_fechaHora=> SYSDATE-14, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>5, P_enfermero=>2, P_paciente=>101, P_medio=>4, P_patologia=>7, P_fechaHora=> SYSDATE-6, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>17, P_enfermero=>9, P_paciente=>3, P_medio=>4, P_patologia=>93, P_fechaHora=> SYSDATE-1, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>6, P_enfermero=>10, P_paciente=>24, P_medio=>2, P_patologia=>84, P_fechaHora=> SYSDATE-10, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>15, P_enfermero=>7, P_paciente=>57, P_medio=>1, P_patologia=>44, P_fechaHora=> SYSDATE-2, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>16, P_enfermero=>13, P_paciente=>38, P_medio=>5, P_patologia=>35, P_fechaHora=> SYSDATE-10, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>11, P_enfermero=>3, P_paciente=>47, P_medio=>5, P_patologia=>8, P_fechaHora=> SYSDATE-6, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>5, P_enfermero=>9, P_paciente=>93, P_medio=>2, P_patologia=>70, P_fechaHora=> SYSDATE-6, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>13, P_enfermero=>8, P_paciente=>117, P_medio=>4, P_patologia=>5, P_fechaHora=> SYSDATE-11, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>1, P_enfermero=>12, P_paciente=>11, P_medio=>5, P_patologia=>16, P_fechaHora=> SYSDATE-14, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>13, P_enfermero=>8, P_paciente=>52, P_medio=>4, P_patologia=>97, P_fechaHora=> SYSDATE-7, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>8, P_enfermero=>19, P_paciente=>129, P_medio=>4, P_patologia=>8, P_fechaHora=> SYSDATE-14, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>2, P_enfermero=>12, P_paciente=>72, P_medio=>5, P_patologia=>97, P_fechaHora=> SYSDATE-10, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>3, P_enfermero=>19, P_paciente=>103, P_medio=>4, P_patologia=>73, P_fechaHora=> SYSDATE-9, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>15, P_enfermero=>5, P_paciente=>135, P_medio=>5, P_patologia=>47, P_fechaHora=> SYSDATE-11, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>15, P_enfermero=>16, P_paciente=>177, P_medio=>2, P_patologia=>67, P_fechaHora=> SYSDATE-1, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>18, P_enfermero=>14, P_paciente=>169, P_medio=>4, P_patologia=>20, P_fechaHora=> SYSDATE-12, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>19, P_enfermero=>17, P_paciente=>176, P_medio=>3, P_patologia=>32, P_fechaHora=> SYSDATE-1, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>13, P_enfermero=>3, P_paciente=>185, P_medio=>3, P_patologia=>81, P_fechaHora=> SYSDATE-11, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>17, P_enfermero=>10, P_paciente=>135, P_medio=>3, P_patologia=>71, P_fechaHora=> SYSDATE-13, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>16, P_enfermero=>19, P_paciente=>70, P_medio=>1, P_patologia=>76, P_fechaHora=> SYSDATE-3, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>7, P_enfermero=>7, P_paciente=>163, P_medio=>5, P_patologia=>20, P_fechaHora=> SYSDATE-10, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>6, P_enfermero=>14, P_paciente=>38, P_medio=>4, P_patologia=>97, P_fechaHora=> SYSDATE-14, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>19, P_enfermero=>12, P_paciente=>113, P_medio=>1, P_patologia=>27, P_fechaHora=> SYSDATE-2, P_asistencia=>1, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>16, P_enfermero=>12, P_paciente=>79, P_medio=>5, P_patologia=>34, P_fechaHora=> SYSDATE-10, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>7, P_enfermero=>13, P_paciente=>23, P_medio=>5, P_patologia=>47, P_fechaHora=> SYSDATE-4, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>7, P_enfermero=>1, P_paciente=>33, P_medio=>2, P_patologia=>61, P_fechaHora=> SYSDATE-9, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>1, P_enfermero=>16, P_paciente=>104, P_medio=>5, P_patologia=>19, P_fechaHora=> SYSDATE-13, P_asistencia=>0, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>12, P_enfermero=>6, P_paciente=>177, P_medio=>1, P_patologia=>32, P_fechaHora=> SYSDATE-11, P_asistencia=>1, P_urgencia=>1, resultado=>salida);
altaCita(P_medico =>14, P_enfermero=>10, P_paciente=>50, P_medio=>3, P_patologia=>22, P_fechaHora=> SYSDATE-11, P_asistencia=>0, P_urgencia=>0, resultado=>salida);
altaCita(P_medico =>4, P_enfermero=>10, P_paciente=>164, P_medio=>2, P_patologia=>16, P_fechaHora=> SYSDATE-14, P_asistencia=>1, P_urgencia=>1, resultado=>salida);

--Insertar datos Tratamientos
altaTratamiento(P_patologia =>1, P_farmaco=>12, P_medico=>6, P_fechaInicio=> SYSDATE-9, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>2, P_farmaco=>136, P_medico=>15, P_fechaInicio=> SYSDATE-12, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>3, P_farmaco=>159, P_medico=>15, P_fechaInicio=> SYSDATE-11, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>4, P_farmaco=>137, P_medico=>8, P_fechaInicio=> SYSDATE-7, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>5, P_farmaco=>90, P_medico=>13, P_fechaInicio=> SYSDATE-8, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>6, P_farmaco=>51, P_medico=>2, P_fechaInicio=> SYSDATE-1, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>7, P_farmaco=>66, P_medico=>3, P_fechaInicio=> SYSDATE-4, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>8, P_farmaco=>2, P_medico=>10, P_fechaInicio=> SYSDATE-7, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>9, P_farmaco=>88, P_medico=>12, P_fechaInicio=> SYSDATE-14, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>10, P_farmaco=>173, P_medico=>10, P_fechaInicio=> SYSDATE-4, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>11, P_farmaco=>37, P_medico=>19, P_fechaInicio=> SYSDATE-7, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>12, P_farmaco=>9, P_medico=>4, P_fechaInicio=> SYSDATE-6, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>13, P_farmaco=>39, P_medico=>7, P_fechaInicio=> SYSDATE-8, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>14, P_farmaco=>92, P_medico=>3, P_fechaInicio=> SYSDATE-6, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>15, P_farmaco=>83, P_medico=>1, P_fechaInicio=> SYSDATE-5, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>16, P_farmaco=>147, P_medico=>4, P_fechaInicio=> SYSDATE-10, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>17, P_farmaco=>124, P_medico=>4, P_fechaInicio=> SYSDATE-4, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>18, P_farmaco=>10, P_medico=>7, P_fechaInicio=> SYSDATE-4, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>19, P_farmaco=>33, P_medico=>1, P_fechaInicio=> SYSDATE-4, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>20, P_farmaco=>51, P_medico=>2, P_fechaInicio=> SYSDATE-1, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>21, P_farmaco=>133, P_medico=>3, P_fechaInicio=> SYSDATE-3, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>22, P_farmaco=>63, P_medico=>2, P_fechaInicio=> SYSDATE-3, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>23, P_farmaco=>94, P_medico=>6, P_fechaInicio=> SYSDATE-4, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>24, P_farmaco=>14, P_medico=>7, P_fechaInicio=> SYSDATE-5, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>25, P_farmaco=>173, P_medico=>4, P_fechaInicio=> SYSDATE-3, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>26, P_farmaco=>51, P_medico=>4, P_fechaInicio=> SYSDATE-2, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>27, P_farmaco=>35, P_medico=>5, P_fechaInicio=> SYSDATE-2, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>28, P_farmaco=>82, P_medico=>8, P_fechaInicio=> SYSDATE-4, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>29, P_farmaco=>170, P_medico=>11, P_fechaInicio=> SYSDATE-5, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>30, P_farmaco=>137, P_medico=>11, P_fechaInicio=> SYSDATE-4, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>31, P_farmaco=>72, P_medico=>14, P_fechaInicio=> SYSDATE-3, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>32, P_farmaco=>110, P_medico=>8, P_fechaInicio=> SYSDATE-7, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>33, P_farmaco=>117, P_medico=>3, P_fechaInicio=> SYSDATE-3, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>34, P_farmaco=>2, P_medico=>5, P_fechaInicio=> SYSDATE-2, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>35, P_farmaco=>130, P_medico=>2, P_fechaInicio=> SYSDATE-1, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>36, P_farmaco=>48, P_medico=>1, P_fechaInicio=> SYSDATE-2, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>37, P_farmaco=>68, P_medico=>9, P_fechaInicio=> SYSDATE-3, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>38, P_farmaco=>140, P_medico=>13, P_fechaInicio=> SYSDATE-2, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>39, P_farmaco=>7, P_medico=>12, P_fechaInicio=> SYSDATE-1, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>40, P_farmaco=>190, P_medico=>11, P_fechaInicio=> SYSDATE-4, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>41, P_farmaco=>50, P_medico=>15, P_fechaInicio=> SYSDATE-4, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>42, P_farmaco=>189, P_medico=>17, P_fechaInicio=> SYSDATE-4, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>43, P_farmaco=>172, P_medico=>14, P_fechaInicio=> SYSDATE-5, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>44, P_farmaco=>142, P_medico=>11, P_fechaInicio=> SYSDATE-2, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>45, P_farmaco=>137, P_medico=>4, P_fechaInicio=> SYSDATE-2, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>46, P_farmaco=>153, P_medico=>3, P_fechaInicio=> SYSDATE-3, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>47, P_farmaco=>59, P_medico=>1, P_fechaInicio=> SYSDATE-4, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>48, P_farmaco=>176, P_medico=>2, P_fechaInicio=> SYSDATE-4, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>49, P_farmaco=>153, P_medico=>8, P_fechaInicio=> SYSDATE-3, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>50, P_farmaco=>135, P_medico=>7, P_fechaInicio=> SYSDATE-2, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>51, P_farmaco=>187, P_medico=>9, P_fechaInicio=> SYSDATE-3, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>52, P_farmaco=>191, P_medico=>1, P_fechaInicio=> SYSDATE-3, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>53, P_farmaco=>176, P_medico=>9, P_fechaInicio=> SYSDATE-2, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>54, P_farmaco=>37, P_medico=>7, P_fechaInicio=> SYSDATE-3, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>55, P_farmaco=>161, P_medico=>6, P_fechaInicio=> SYSDATE-1, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>56, P_farmaco=>88, P_medico=>1, P_fechaInicio=> SYSDATE-6, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>57, P_farmaco=>52, P_medico=>9, P_fechaInicio=> SYSDATE-2, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>58, P_farmaco=>31, P_medico=>4, P_fechaInicio=> SYSDATE-4, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>59, P_farmaco=>126, P_medico=>4, P_fechaInicio=> SYSDATE-9, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>60, P_farmaco=>41, P_medico=>2, P_fechaInicio=> SYSDATE-1, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>61, P_farmaco=>69, P_medico=>1, P_fechaInicio=> SYSDATE-5, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>62, P_farmaco=>107, P_medico=>1, P_fechaInicio=> SYSDATE-2, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>63, P_farmaco=>81, P_medico=>7, P_fechaInicio=> SYSDATE-5, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>64, P_farmaco=>116, P_medico=>2, P_fechaInicio=> SYSDATE-4, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>65, P_farmaco=>149, P_medico=>1, P_fechaInicio=> SYSDATE-3, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>66, P_farmaco=>195, P_medico=>2, P_fechaInicio=> SYSDATE-4, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>67, P_farmaco=>148, P_medico=>6, P_fechaInicio=> SYSDATE-5, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>68, P_farmaco=>72, P_medico=>6, P_fechaInicio=> SYSDATE-1, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>69, P_farmaco=>14, P_medico=>6, P_fechaInicio=> SYSDATE-3, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>70, P_farmaco=>43, P_medico=>10, P_fechaInicio=> SYSDATE-1, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>71, P_farmaco=>87, P_medico=>19, P_fechaInicio=> SYSDATE-3, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>72, P_farmaco=>144, P_medico=>17, P_fechaInicio=> SYSDATE-1, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>73, P_farmaco=>155, P_medico=>7, P_fechaInicio=> SYSDATE-4, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>74, P_farmaco=>119, P_medico=>18, P_fechaInicio=> SYSDATE-5, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>75, P_farmaco=>172, P_medico=>8, P_fechaInicio=> SYSDATE-2, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>76, P_farmaco=>137, P_medico=>10, P_fechaInicio=> SYSDATE-1, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>77, P_farmaco=>191, P_medico=>1, P_fechaInicio=> SYSDATE-3, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>78, P_farmaco=>148, P_medico=>2, P_fechaInicio=> SYSDATE-3, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>79, P_farmaco=>26, P_medico=>10, P_fechaInicio=> SYSDATE-1, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>80, P_farmaco=>19, P_medico=>15, P_fechaInicio=> SYSDATE-2, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>81, P_farmaco=>122, P_medico=> 1, P_fechaInicio=> SYSDATE-4, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>82, P_farmaco=>60, P_medico=> 2, P_fechaInicio=> SYSDATE-3, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>83, P_farmaco=>3, P_medico=> 3, P_fechaInicio=> SYSDATE-1, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>84, P_farmaco=>108, P_medico=> 14, P_fechaInicio=> SYSDATE-1, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>85, P_farmaco=>41, P_medico=> 9, P_fechaInicio=> SYSDATE-1, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>86, P_farmaco=>173, P_medico=> 8, P_fechaInicio=> SYSDATE-1, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>87, P_farmaco=>162, P_medico=> 7, P_fechaInicio=> SYSDATE-3, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>88, P_farmaco=>149, P_medico=> 16, P_fechaInicio=> SYSDATE-2, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>89, P_farmaco=>134, P_medico=> 5, P_fechaInicio=> SYSDATE-3, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>90, P_farmaco=>68, P_medico=> 4, P_fechaInicio=> SYSDATE-4, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>91, P_farmaco=>134, P_medico=> 13, P_fechaInicio=> SYSDATE-2, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>92, P_farmaco=>198, P_medico=> 5, P_fechaInicio=> SYSDATE-4, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>93, P_farmaco=>193, P_medico=> 16, P_fechaInicio=> SYSDATE-3, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>94, P_farmaco=>137, P_medico=> 7, P_fechaInicio=> SYSDATE-1, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>95, P_farmaco=>113, P_medico=> 18, P_fechaInicio=> SYSDATE-4, P_fechaFin=> SYSDATE, P_periodicidad=>1, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>96, P_farmaco=>176, P_medico=> 9, P_fechaInicio=> SYSDATE-2, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>2, resultado=>salida);
altaTratamiento(P_patologia =>97, P_farmaco=>8, P_medico=> 14, P_fechaInicio=> SYSDATE-3, P_fechaFin=> SYSDATE, P_periodicidad=>4, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>98, P_farmaco=>125, P_medico=> 3, P_fechaInicio=> SYSDATE-2, P_fechaFin=> SYSDATE, P_periodicidad=>3, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>99, P_farmaco=>193, P_medico=> 2, P_fechaInicio=> SYSDATE-4, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>1, resultado=>salida);
altaTratamiento(P_patologia =>100, P_farmaco=>179, P_medico=> 11, P_fechaInicio=> SYSDATE-1, P_fechaFin=> SYSDATE, P_periodicidad=>2, P_cantidad=>2, resultado=>salida);

--Insertar datos Administraciones de tratamientos
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-9, P_periodo=>1, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-9, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-9, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-9, P_periodo=>4, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-8, P_periodo=>1, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-8, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-8, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-8, P_periodo=>4, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-7, P_periodo=>1, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-7, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-7, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-7, P_periodo=>4, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-6, P_periodo=>1, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-6, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-6, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-6, P_periodo=>4, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-5, P_periodo=>1, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-5, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-5, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-5, P_periodo=>4, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-4, P_periodo=>1, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-4, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-4, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-4, P_periodo=>4, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-3, P_periodo=>1, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-3, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-3, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-3, P_periodo=>4, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-2, P_periodo=>1, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-2, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-2, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-2, P_periodo=>4, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-1, P_periodo=>1, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-1, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-1, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>1, P_fecha=> SYSDATE-1, P_periodo=>4, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>8, P_tratamiento=>2, P_fecha=> SYSDATE-12, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>1, P_tratamiento=>3, P_fecha=> SYSDATE-11, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>15, P_tratamiento=>4, P_fecha=> SYSDATE-7, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>7, P_tratamiento=>5, P_fecha=> SYSDATE-8, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>16, P_tratamiento=>6, P_fecha=> SYSDATE-1, P_periodo=>4, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>8, P_tratamiento=>7, P_fecha=> SYSDATE-4, P_periodo=>4, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>6, P_tratamiento=>8, P_fecha=> SYSDATE-7, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>5, P_tratamiento=>9, P_fecha=> SYSDATE-14, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>1, P_tratamiento=>10, P_fecha=> SYSDATE-4, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>14, P_tratamiento=>11, P_fecha=> SYSDATE-7, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>18, P_tratamiento=>12, P_fecha=> SYSDATE-6, P_periodo=>4, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>6, P_tratamiento=>13, P_fecha=> SYSDATE-8, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>12, P_tratamiento=>14, P_fecha=> SYSDATE-6, P_periodo=>4, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>13, P_tratamiento=>15, P_fecha=> SYSDATE-5, P_periodo=>3, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>15, P_tratamiento=>16, P_fecha=> SYSDATE-10, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>17, P_fecha=> SYSDATE-4, P_periodo=>1, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>12, P_tratamiento=>18, P_fecha=> SYSDATE-4, P_periodo=>1, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>3, P_tratamiento=>19, P_fecha=> SYSDATE-4, P_periodo=>4, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>18, P_tratamiento=>20, P_fecha=> SYSDATE-1, P_periodo=>4, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>9, P_tratamiento=>21, P_fecha=> SYSDATE-3, P_periodo=>3, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>18, P_tratamiento=>22, P_fecha=> SYSDATE-3, P_periodo=>2, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>18, P_tratamiento=>23, P_fecha=> SYSDATE-4, P_periodo=>1, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>6, P_tratamiento=>24, P_fecha=> SYSDATE-5, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>1, P_tratamiento=>25, P_fecha=> SYSDATE-3, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>16, P_tratamiento=>26, P_fecha=> SYSDATE-2, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>5, P_tratamiento=>27, P_fecha=> SYSDATE-2, P_periodo=>4, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>17, P_tratamiento=>28, P_fecha=> SYSDATE-4, P_periodo=>4, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>18, P_tratamiento=>29, P_fecha=> SYSDATE-5, P_periodo=>4, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>5, P_tratamiento=>30, P_fecha=> SYSDATE-4, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>3, P_tratamiento=>31, P_fecha=> SYSDATE-3, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>14, P_tratamiento=>32, P_fecha=> SYSDATE-7, P_periodo=>1, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>1, P_tratamiento=>33, P_fecha=> SYSDATE-3, P_periodo=>1, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>17, P_tratamiento=>34, P_fecha=> SYSDATE-2, P_periodo=>2, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>6, P_tratamiento=>35, P_fecha=> SYSDATE-1, P_periodo=>2, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>12, P_tratamiento=>36, P_fecha=> SYSDATE-2, P_periodo=>1, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>1, P_tratamiento=>37, P_fecha=> SYSDATE-3, P_periodo=>1, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>11, P_tratamiento=>38, P_fecha=> SYSDATE-2, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>3, P_tratamiento=>39, P_fecha=> SYSDATE-1, P_periodo=>1, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>8, P_tratamiento=>40, P_fecha=> SYSDATE-4, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>11, P_tratamiento=>41, P_fecha=> SYSDATE-4, P_periodo=>3, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>8, P_tratamiento=>42, P_fecha=> SYSDATE-4, P_periodo=>1, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>7, P_tratamiento=>43, P_fecha=> SYSDATE-5, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>19, P_tratamiento=>44, P_fecha=> SYSDATE-2, P_periodo=>4, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>16, P_tratamiento=>45, P_fecha=> SYSDATE-2, P_periodo=>1, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>2, P_tratamiento=>46, P_fecha=> SYSDATE-3, P_periodo=>2, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>10, P_tratamiento=>47, P_fecha=> SYSDATE-4, P_periodo=>4, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>10, P_tratamiento=>48, P_fecha=> SYSDATE-4, P_periodo=>3, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>7, P_tratamiento=>49, P_fecha=> SYSDATE-3, P_periodo=>4, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>17, P_tratamiento=>50, P_fecha=> SYSDATE-2, P_periodo=>4, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>8, P_tratamiento=>51, P_fecha=> SYSDATE-3, P_periodo=>3, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>1, P_tratamiento=>52, P_fecha=> SYSDATE-3, P_periodo=>4, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>1, P_tratamiento=>53, P_fecha=> SYSDATE-2, P_periodo=>1, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>5, P_tratamiento=>54, P_fecha=> SYSDATE-3, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>15, P_tratamiento=>55, P_fecha=> SYSDATE-1, P_periodo=>1, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>1, P_tratamiento=>56, P_fecha=> SYSDATE-6, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>7, P_tratamiento=>57, P_fecha=> SYSDATE-2, P_periodo=>1, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>6, P_tratamiento=>58, P_fecha=> SYSDATE-4, P_periodo=>4, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>6, P_tratamiento=>59, P_fecha=> SYSDATE-9, P_periodo=>4, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>8, P_tratamiento=>60, P_fecha=> SYSDATE-1, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>8, P_tratamiento=>61, P_fecha=> SYSDATE-5, P_periodo=>1, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>16, P_tratamiento=>62, P_fecha=> SYSDATE-2, P_periodo=>1, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>12, P_tratamiento=>63, P_fecha=> SYSDATE-5, P_periodo=>4, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>9, P_tratamiento=>64, P_fecha=> SYSDATE-4, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>16, P_tratamiento=>65, P_fecha=> SYSDATE-3, P_periodo=>4, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>18, P_tratamiento=>66, P_fecha=> SYSDATE-4, P_periodo=>3, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>6, P_tratamiento=>67, P_fecha=> SYSDATE-5, P_periodo=>4, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>12, P_tratamiento=>68, P_fecha=> SYSDATE-1, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>8, P_tratamiento=>69, P_fecha=> SYSDATE-3, P_periodo=>1, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>6, P_tratamiento=>70, P_fecha=> SYSDATE-1, P_periodo=>2, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>6, P_tratamiento=>71, P_fecha=> SYSDATE-3, P_periodo=>1, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>16, P_tratamiento=>72, P_fecha=> SYSDATE-1, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>8, P_tratamiento=>73, P_fecha=> SYSDATE-4, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>19, P_tratamiento=>74, P_fecha=> SYSDATE-5, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>19, P_tratamiento=>75, P_fecha=> SYSDATE-2, P_periodo=>4, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>17, P_tratamiento=>76, P_fecha=> SYSDATE-1, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>11, P_tratamiento=>77, P_fecha=> SYSDATE-3, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>11, P_tratamiento=>78, P_fecha=> SYSDATE-3, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>5, P_tratamiento=>79, P_fecha=> SYSDATE-1, P_periodo=>3, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>5, P_tratamiento=>80, P_fecha=> SYSDATE-2, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>3, P_tratamiento=>81, P_fecha=> SYSDATE-4, P_periodo=>1, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>14, P_tratamiento=>82, P_fecha=> SYSDATE-3, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>18, P_tratamiento=>83, P_fecha=> SYSDATE-1, P_periodo=>1, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>1, P_tratamiento=>84, P_fecha=> SYSDATE-1, P_periodo=>4, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>14, P_tratamiento=>85, P_fecha=> SYSDATE-1, P_periodo=>2, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>8, P_tratamiento=>86, P_fecha=> SYSDATE-1, P_periodo=>3, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>15, P_tratamiento=>87, P_fecha=> SYSDATE-3, P_periodo=>2, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>3, P_tratamiento=>88, P_fecha=> SYSDATE-2, P_periodo=>1, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>15, P_tratamiento=>89, P_fecha=> SYSDATE-3, P_periodo=>2, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>8, P_tratamiento=>90, P_fecha=> SYSDATE-4, P_periodo=>1, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>3, P_tratamiento=>91, P_fecha=> SYSDATE-2, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>8, P_tratamiento=>92, P_fecha=> SYSDATE-4, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>17, P_tratamiento=>93, P_fecha=> SYSDATE-3, P_periodo=>1, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>12, P_tratamiento=>94, P_fecha=> SYSDATE-1, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>2, P_tratamiento=>95, P_fecha=> SYSDATE-4, P_periodo=>1, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>96, P_fecha=> SYSDATE-2, P_periodo=>2, P_cantidad=>2, resultado=>salida);
altaAdministracion(P_enfermero =>18, P_tratamiento=>97, P_fecha=> SYSDATE-3, P_periodo=>4, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>7, P_tratamiento=>98, P_fecha=> SYSDATE-2, P_periodo=>3, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>4, P_tratamiento=>99, P_fecha=> SYSDATE-4, P_periodo=>2, P_cantidad=>1, resultado=>salida);
altaAdministracion(P_enfermero =>19, P_tratamiento=>100, P_fecha=> SYSDATE-1, P_periodo=>2, P_cantidad=>2, resultado=>salida);

--Insertar datos pruebas de patologas de pacientes
altaPrueba(P_patologia =>27, P_tipo=>123, P_fechaHora=> SYSDATE-14, registro=>salida);
altaPrueba(P_patologia =>69, P_tipo=>42, P_fechaHora=> SYSDATE-16, registro=>salida);
altaPrueba(P_patologia =>33, P_tipo=>145, P_fechaHora=> SYSDATE-17, registro=>salida);
altaPrueba(P_patologia =>59, P_tipo=>7, P_fechaHora=> SYSDATE-11, registro=>salida);
altaPrueba(P_patologia =>78, P_tipo=>81, P_fechaHora=> SYSDATE-2, registro=>salida);
altaPrueba(P_patologia =>82, P_tipo=>110, P_fechaHora=> SYSDATE-5, registro=>salida);
altaPrueba(P_patologia =>49, P_tipo=>45, P_fechaHora=> SYSDATE-11, registro=>salida);
altaPrueba(P_patologia =>19, P_tipo=>176, P_fechaHora=> SYSDATE-14, registro=>salida);
altaPrueba(P_patologia =>31, P_tipo=>66, P_fechaHora=> SYSDATE-18, registro=>salida);
altaPrueba(P_patologia =>10, P_tipo=>135, P_fechaHora=> SYSDATE-10, registro=>salida);
altaPrueba(P_patologia =>21, P_tipo=>68, P_fechaHora=> SYSDATE-3, registro=>salida);
altaPrueba(P_patologia =>33, P_tipo=>116, P_fechaHora=> SYSDATE-17, registro=>salida);
altaPrueba(P_patologia =>88, P_tipo=>130, P_fechaHora=> SYSDATE-7, registro=>salida);
altaPrueba(P_patologia =>84, P_tipo=>43, P_fechaHora=> SYSDATE-1, registro=>salida);
altaPrueba(P_patologia =>18, P_tipo=>40, P_fechaHora=> SYSDATE-15, registro=>salida);
altaPrueba(P_patologia =>25, P_tipo=>30, P_fechaHora=> SYSDATE-7, registro=>salida);
altaPrueba(P_patologia =>94, P_tipo=>31, P_fechaHora=> SYSDATE-5, registro=>salida);
altaPrueba(P_patologia =>93, P_tipo=>129, P_fechaHora=> SYSDATE-13, registro=>salida);
altaPrueba(P_patologia =>60, P_tipo=>61, P_fechaHora=> SYSDATE-14, registro=>salida);
altaPrueba(P_patologia =>54, P_tipo=>9, P_fechaHora=> SYSDATE-14, registro=>salida);
altaPrueba(P_patologia =>68, P_tipo=>1, P_fechaHora=> SYSDATE-2, registro=>salida);
altaPrueba(P_patologia =>89, P_tipo=>18, P_fechaHora=> SYSDATE-19, registro=>salida);
altaPrueba(P_patologia =>90, P_tipo=>118, P_fechaHora=> SYSDATE-2, registro=>salida);
altaPrueba(P_patologia =>15, P_tipo=>124, P_fechaHora=> SYSDATE-15, registro=>salida);
altaPrueba(P_patologia =>2, P_tipo=>87, P_fechaHora=> SYSDATE-19, registro=>salida);
altaPrueba(P_patologia =>11, P_tipo=>153, P_fechaHora=> SYSDATE-18, registro=>salida);
altaPrueba(P_patologia =>54, P_tipo=>113, P_fechaHora=> SYSDATE-11, registro=>salida);
altaPrueba(P_patologia =>45, P_tipo=>138, P_fechaHora=> SYSDATE-1, registro=>salida);
altaPrueba(P_patologia =>52, P_tipo=>171, P_fechaHora=> SYSDATE-7, registro=>salida);
altaPrueba(P_patologia =>70, P_tipo=>115, P_fechaHora=> SYSDATE-13, registro=>salida);
altaPrueba(P_patologia =>5, P_tipo=>64, P_fechaHora=> SYSDATE-6, registro=>salida);
altaPrueba(P_patologia =>18, P_tipo=>132, P_fechaHora=> SYSDATE-16, registro=>salida);
altaPrueba(P_patologia =>84, P_tipo=>156, P_fechaHora=> SYSDATE-3, registro=>salida);
altaPrueba(P_patologia =>52, P_tipo=>11, P_fechaHora=> SYSDATE-2, registro=>salida);
altaPrueba(P_patologia =>51, P_tipo=>142, P_fechaHora=> SYSDATE-10, registro=>salida);
altaPrueba(P_patologia =>87, P_tipo=>49, P_fechaHora=> SYSDATE-16, registro=>salida);
altaPrueba(P_patologia =>80, P_tipo=>117, P_fechaHora=> SYSDATE-16, registro=>salida);
altaPrueba(P_patologia =>93, P_tipo=>31, P_fechaHora=> SYSDATE-2, registro=>salida);
altaPrueba(P_patologia =>17, P_tipo=>84, P_fechaHora=> SYSDATE-6, registro=>salida);
altaPrueba(P_patologia =>60, P_tipo=>37, P_fechaHora=> SYSDATE-10, registro=>salida);
altaPrueba(P_patologia =>46, P_tipo=>95, P_fechaHora=> SYSDATE-19, registro=>salida);
altaPrueba(P_patologia =>18, P_tipo=>99, P_fechaHora=> SYSDATE-4, registro=>salida);
altaPrueba(P_patologia =>6, P_tipo=>25, P_fechaHora=> SYSDATE-18, registro=>salida);
altaPrueba(P_patologia =>64, P_tipo=>81, P_fechaHora=> SYSDATE-19, registro=>salida);
altaPrueba(P_patologia =>56, P_tipo=>37, P_fechaHora=> SYSDATE-19, registro=>salida);
altaPrueba(P_patologia =>41, P_tipo=>12, P_fechaHora=> SYSDATE-14, registro=>salida);
altaPrueba(P_patologia =>54, P_tipo=>94, P_fechaHora=> SYSDATE-4, registro=>salida);
altaPrueba(P_patologia =>78, P_tipo=>109, P_fechaHora=> SYSDATE-2, registro=>salida);
altaPrueba(P_patologia =>3, P_tipo=>124, P_fechaHora=> SYSDATE-12, registro=>salida);
altaPrueba(P_patologia =>45, P_tipo=>66, P_fechaHora=> SYSDATE-5, registro=>salida);

END;

